var EXPORTED_SYMBOLS = ["toolbar", "treeView", "neworkGUI"]; 

Components.utils.import("resource://qfn/qfnServices.js");
var window;
var document;
var QuickFoxNotes;
function _(aID) {
  return document.getElementById(aID);
}

toolbar = {
	getElem: function (row) {
		var elem = treeView.tData;
		for (var i = 1; i < treeView.view[row].length; i++)
			elem = elem[treeView.view[row][i]];
		if (elem.constructor == Array)	//If element is folder
			elem = elem[0];
		return elem;
	},
	updateToolbar: function() {
		var netbar = _("network-toolbar");
		var tree = _("network-tree");
		
		function doAtt(arr) {	//[refresh, delete, paste to QFN, newFile, newFolder]
			for (var i = 0; i < arr.length; i++)
				netbar.childNodes[i].setAttribute("disabled", !arr[i]);
		}
		
		var row = tree.currentIndex;
		var level = treeView.getLevel(row);
		
		var service = neworkGUI.pathToArray(this.getElem(row).path)[0];

		//Check file status
		var canFile = true;
		if(service == "evernote" && level == 0)
			canFile = false;
		if(service == "sugarsync" && level < 2)
			canFile = false;
		//Check folder status
		if (treeView.isContainer(row)){
			var canFolder = false;
			switch (service) {
				case "googleDocs":
				case "simplenote":
					canFolder = false;
					break;
				case "evernote":
					canFolder = (level == 0) ? true : false;
					break;
				case "sugarsync":
					canFolder = (level > 1) ? true : false;
					break;
				case "local":
					canFolder = true;
			}
			//Set Attributes in Folder mode
			doAtt([true, false, false, canFile, canFolder]);
		}
		else//Set Attributes in File mode
			doAtt([true, true, true, canFile, false]);
	},
	doRefresh: function(){
		neworkGUI.fprint(3);
		
		var tree = _("network-tree");
		var row = tree.currentIndex;
		
		if (!treeView.isContainer(row)) {
			row = treeView.getParentIndex(row);
			tree.currentIndex = row;
		}
		
		isOpen = treeView.isContainerOpen(row);
		
		var root = treeView.tData;
		for (var i = 1; i < treeView.view[row].length; i++)
			root = root[treeView.view[row][i]];
		root.splice(1, root.length - 1);
		treeView.toggleOpenState(row);
		if (isOpen) treeView.toggleOpenState(row);
	},
	doRead: function() {
		neworkGUI.fprint(4);
		
		var tree = _("network-tree");
		var row = tree.currentIndex;
		
		elem = this.getElem(row);
		var service = neworkGUI.pathToArray(elem.path)[0];
		var token = neworkGUI.token[service];
		
		neworkGUI.initialize(service, function(){
			var token = neworkGUI.token[service];
			switch (service) {
				case "evernote":
					QuickFoxNotes.network[service].getNoteContent (token, elem.guid, function(content){neworkGUI.fprint(1); QuickFoxNotes.api.insertTextAtCursorPoint(content)}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "googleDocs":
					QuickFoxNotes.network[service].readFile (token, elem.contentURL, function(content){neworkGUI.fprint(1); QuickFoxNotes.api.insertTextAtCursorPoint(content)}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "simplenote":
					QuickFoxNotes.network[service].getContent (token, elem.key, function(content){neworkGUI.fprint(1); QuickFoxNotes.api.insertTextAtCursorPoint(content)}, [], function(e){neworkGUI.error(e)});
					break;
				case "sugarsync":
					QuickFoxNotes.network[service].readFile (token, elem.url, function(content){neworkGUI.fprint(1); QuickFoxNotes.api.insertTextAtCursorPoint(content)}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "local":
					QuickFoxNotes.network[service].readFile(elem.url, function(){neworkGUI.fprint(1);}, [], function(e){neworkGUI.error(e)});
					break;
			}
		});
	},
	doDelete: function() {
		neworkGUI.fprint(2);
		
		var tree = _("network-tree");
		
		var row = tree.currentIndex;
		var elem = this.getElem(row);
		var service = neworkGUI.pathToArray(elem.path)[0];
		
		var token = neworkGUI.token[service];
		//Move to top
		parentRow = treeView.getParentIndex(row);
		tree.currentIndex = parentRow;
		
		//Confirm
		if (!window.confirm(QuickFoxNotes.stringsBundle.getString('network16')))	//0 is cancel
			return;
			
		neworkGUI.initialize(service, function(){
			var token = neworkGUI.token[service];
			switch (service) {
				case "evernote":
					QuickFoxNotes.network[service].deleteNote (token, elem.guid, function(){toolbar.doRefresh();}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "googleDocs":
					QuickFoxNotes.network[service].deleteFile (token, elem.editURL, function(){toolbar.doRefresh();}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "simplenote":
					QuickFoxNotes.network[service].kill (token, elem.key, function(){toolbar.doRefresh();}, [], function(e){neworkGUI.error(e)});
					break;
				case "sugarsync":
					QuickFoxNotes.network[service].kill(token, elem.url, function(){toolbar.doRefresh();}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "local":
					QuickFoxNotes.network[service].kill(elem.url, treeView.isContainer(row), function(){toolbar.doRefresh();}, [], function(e){neworkGUI.error(e)});
					break;
			}
		});
	},
	doNewFile: function() {
		neworkGUI.fprint(5);
		
		var tree = _("network-tree");
		var row = tree.currentIndex;
		
		//If file, go to top folder
		if (!treeView.isContainer(row)) {
			row = treeView.getParentIndex(row);
			tree.currentIndex = row;
		}
		
		var elem = this.getElem(row);
		var service = neworkGUI.pathToArray(elem.path)[0];
		
		var token = neworkGUI.token[service];
		
		title = QuickFoxNotes.api.get.noteTitle();
		content = QuickFoxNotes.api.get.noteContent();
		
		neworkGUI.initialize(service, function(){
			var token = neworkGUI.token[service];
			switch (service) {
				case "evernote":
					QuickFoxNotes.network[service].createNote (token, elem.notebookGuid, title, content, function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "googleDocs":
					var url = "https://docs.google.com/feeds/default/private/full";
					QuickFoxNotes.network[service].createFile (token, url, title, content.replace(/\n/g, String.fromCharCode(13, 10)), function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "simplenote":
					QuickFoxNotes.network[service].write (token, "", content, function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "sugarsync":
					QuickFoxNotes.network[service].createFile (token, elem.url, title + ".txt", content.replace(/\n/g, String.fromCharCode(13, 10)), function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "local":
					QuickFoxNotes.network[service].writeFile(elem.url, title, content.replace(/\n/g, String.fromCharCode(13, 10)), function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e)});
					break;
			}
		});
	},
	doFolder: function() {
		neworkGUI.fprint(6);
		//Ask for Folder name; if empty use note's title
		var check = {value: false};
		var input = {value: ""};
		var result = qfnServices.prompts.prompt(
			null, 
			QuickFoxNotes.stringsBundle.getString('network8'), QuickFoxNotes.stringsBundle.getString('network9'),
			input, null, check);
		
		if(!result) {
			neworkGUI.fprint(7);
			return;
		}
			
		var tree = _("network-tree");
		var row = tree.currentIndex;
		var elem = this.getElem(row);
		var service = neworkGUI.pathToArray(elem.path)[0];
		var token = neworkGUI.token[service];
		
		title = input.value ? input.value : QuickFoxNotes.api.get.noteTitle();
		
		neworkGUI.initialize(service, function(){
			var token = neworkGUI.token[service];
			switch (service) {
				case "evernote":
					QuickFoxNotes.network[service].createNotebook (token, title, function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e.responseText)});
				case "googleDocs":
				case "simplenote":
					break;
				case "sugarsync":
					QuickFoxNotes.network[service].createFolder (token, elem.url, title, function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e.responseText)});
					break;
				case "local":
					QuickFoxNotes.network[service].createFolder(elem.url, title, function(){toolbar.doRefresh()}, [], function(e){neworkGUI.error(e)});
					break;
			}
		});
	}
}

var treeView = {
	bolInit: false,
	window: null,
	
	init: function(win, force){
		if (this.bolInit && !force)
			return;
	
		window = win;
		document = window.document;
		QuickFoxNotes = window.QuickFoxNotes;
			
		treeView.initTree();
		document.getElementById("network-tree").view = treeView;
		
		neworkGUI.activeServices = [];
		neworkGUI.token = [];
		
		this.bolInit = true;
	},

	/*
	[parentNode, childNode1, childNode2, ...];	//Folder example
	node = {name: "name", ...}

	var tData = [
		{name: "root"},		//Root element
		{name: "e1"},		//example of a file
		{name: "e2"},
		[{name: "e3"}, 		//example of a folder [...]
			{name: "e31"}, 
			{name: "e32"},
			[{name: "e33"},
				{name: "e331"}]
		]
	]
	*/
	tData: [	//[name, elements...]
		{name: "database"},		//first element is mandatory
		[{name: "Local Disk",
		  path: "chrome://local"}
		],
		[{name: "Evernote",
		  path: "chrome://evernote"}
		],
		[{name: "Google Docs",
		  path: "chrome://googleDocs"}
		],
		[{name: "Simplenote",
		  path: "chrome://simplenote"}
		],
		[{name: "Sugarsync",
		  path: "chrome://sugarsync"}
		]
	],
	
	/* Tree functions */
	treeBox: null,
	selection: null,

	initTree: function() {
		this.view = [];
		for (var i = 1; i < this.tData.length; i++)
			this.view.push([this.tData[i].constructor == Array ? this.tData[i][0].name : this.tData[i].name, i]);
	},
	get rowCount() {
		return this.view.length; 
	},
	setTree: function(treeBox) {
		this.treeBox = treeBox;
	},
	getCellText: function(row, column) {
		return this.view[row][0];
	},
	isContainer: function(row) {
		var elem = this.tData;
		for (var i = 1; i < this.view[row].length; i++)
			elem = elem[this.view[row][i]];
			
		return elem.constructor == Array;
	},
	isContainerOpen: function(row) {
		if (row == this.view.length - 1)
			return false;
			
		return (this.view[row + 1].length > this.view[row].length) && (this.view[row + 1][this.view[row].length - 1] == this.view[row][this.view[row].length - 1]);
	},
	isContainerEmpty: function(row) {
		return false;
	},
	_isContainerEmpty: function(row) {
		var elem = this.tData;
		for (var i = 1; i < this.view[row].length; i++)
			elem = elem[this.view[row][i]];
			
		return elem.length == 1;
	},
	isSeparator: function(row) {
		return false; 
	},
	isSorted: function() {
		return false;
	},
	isEditable: function(row, column) {
		return false;
	},
	getParentIndex: function(row) {
		for (var i = row - 1; i >= 0; i--)
			if (this.view[i].length < this.view[row].length)
				return i;
		return -1;
	},
	getLevel: function(row) {
		return this.view[row].length - 2;
	},
	hasNextSibling: function(row, after) {
		var root = this.tData;
		for (var i = 1; i < this.view[row].length - 1; i++)
			root = root[this.view[row][i]];

		return root.length - 2 >  this.view[row][this.view[row].length - 1];
	},
	toggleOpenState: function(row) {
		var isOpen = this.isContainerOpen(row);
		
		if (isOpen || !this._isContainerEmpty(row))
			this._toggleOpenState(row);
		else {
			var elem = this.tData;
			for (var i = 1; i < this.view[row].length; i++)
				elem = elem[this.view[row][i]];
			
			neworkGUI.getList(elem, function(row){
				this._toggleOpenState(row);
				toolbar.updateToolbar();
			}, [row]);
		}
	},
	_toggleOpenState: function(row) {
		var isOpen = this.isContainerOpen(row);
		
		var count = 0;
		if (isOpen){	//Close it!
			while (
				this.isContainerOpen(row) && 
				((this.view[row + 1].length > this.view[row].length) && (this.view[row + 1][this.view[row].length - 1] == this.view[row][this.view[row].length - 1]))
			) {
				this.view.splice(row + 1, 1);
				count += 1;
			}
			this.treeBox.rowCountChanged(row + 1, -count);
		}
		else {	//Open it!
			var elem = this.tData;
			for (var i = 1; i < this.view[row].length; i++)
				elem = elem[this.view[row][i]];

			for (var i = 1; i < elem.length; i++) {
				this.view.splice(row + i, 0, []);
				this.view[row + i] = this.view[row].concat(i);
				this.view[row + i][0] = elem[i].constructor == Array ? elem[i][0].name : elem[i].name;
				
				count += 1;
			}
			this.treeBox.rowCountChanged(row + 1, +count);
		}
		this.treeBox.invalidateRow(row);
	},

	getImageSrc: function(row, column) {},
	getProgressMode : function(row,column) {},
	getCellValue: function(row, column) {},
	cycleHeader: function(col, elem) {},
	selectionChanged: function() {},
	cycleCell: function(row, column) {},
	performAction: function(action) {},
	performActionOnCell: function(action, index, column) {},
	getRowProperties: function(row, prop) {},
	getCellProperties: function(row, column, prop) {	//For root, use network icon
		if (this.getLevel(row) != 0 || !Components)
			return;
	
		var aserv=Components.classes["@mozilla.org/atom-service;1"].
				  getService(Components.interfaces.nsIAtomService);
		prop.AppendElement(aserv.getAtom("network"));
	},
	getColumnProperties: function(column, element, prop) {}
};

var neworkGUI = {
	activeServices: [],	//List of all active services
	token: [],
	
	pathToArray: function(path) {
		path = path.replace("chrome://", "");
		
		return path.split("/");
	},
	initialize: function(service, callback) {
		if (this.activeServices.indexOf(service) == -1) {
			if (service == "local") {
				QuickFoxNotes.network[service].getToken(function(){
					if (callback)
						callback.apply(neworkGUI);
				}, []);
				return;
			}
			//Get login info
			var username = qfnServices.prefs.getCharPref(service + "_username");
			var password = "";
			
			//Try to retrieve password
			if (username)
				password = QuickFoxNotes.api.login.getPassword(service, username);
			
			if (!(username && password)) {
				if (!username) {	//Try to find a user
					var obj = QuickFoxNotes.api.login.getPassword2(service, "");
					if (obj){
						username = obj.username;
						password = obj.password;
					}
				}
			
				var _username = {value: username};
				var _password = {value: password};
				var check = {value: false};
				var result = qfnServices.prompts.promptUsernameAndPassword(null, 
								service, 
								QuickFoxNotes.stringsBundle.getString('network14') + " " + service, 
								_username, _password, 
								QuickFoxNotes.stringsBundle.getString('network15'), check);

				if (!result || !_username.value || !_password.value) {
					this.fprint(7);
					return false;
				}
				
				if (_username.value && !(username && password && !check.value))
					qfnServices.prefs.setCharPref(service + "_username", _username.value);
					
				if (_username.value && _password.value && check.value)
					QuickFoxNotes.api.login.setPassword(service, _username.value, _password.value);
			
				username = _username.value;
				password = _password.value;
			}

			QuickFoxNotes.network[service].getToken(username, password, function(token){
				neworkGUI.token[service] = token;
				neworkGUI.activeServices.push(service);
				if (callback)
					callback.apply(neworkGUI);
			}, [], function(e){
				qfnServices.prefs.setCharPref(service + "_username", "");
				neworkGUI.error(e.responseText);
			});
		}
		else
			callback.apply(this);
	},
	getList: function(element, fun, params) {
		var path = element[0].path;
		this.fprint(0, path);
		if (!path)
			return this.error("neworkGUI.getList; Empty path is not supported!");
			
		aPath = this.pathToArray(path);
		var service = aPath[0];	//root aPath is the service
		
		//Add new items
		this.initialize(service, function(){
			var token = neworkGUI.token[service];
			switch(service){
				case "googleDocs":
					QuickFoxNotes.network[service].getList(token, function(files, rootPath){
						for (var i in files)
							element.splice(element.length, 0, 
								{
									name: files[i].title,
									path: rootPath + "/" + files[i].title,
									editURL: files[i].editURL,
									contentURL: files[i].contentURL
								}
							);
						neworkGUI.fprint(1);
						if (fun) fun.apply(treeView, params);
					}, [path]);
					break;
				case "sugarsync":
					if (aPath.length == 1) {	//Get list of computers
						QuickFoxNotes.network[service].getWorkspaces(token, function(PCs, rootPath){
							for (i in PCs)
								element.splice(element.length, 0, 
									[{
										name: PCs[i].name,
										path: rootPath + "/" + PCs[i].name,
										url: PCs[i].url
									}]
								);
							neworkGUI.fprint(1);
							if (fun) fun.apply(treeView, params);
						}, [path]);
					}
					else {
						//Add files and folders
						QuickFoxNotes.network[service].getContents(token, element[0].url, function(folderURL, fileURL, parentURL, rootPath){
							//Add Files
							QuickFoxNotes.network[service].getList(token, fileURL, "file", function(list, rootPath, folderURL){
								for (j in list)
									element.splice(element.length, 0, 
										{
											name: list[j].name,
											path: rootPath + "/" + list[j].name,
											url: list[j].url
										}
									);
								//Add Folders
								QuickFoxNotes.network[service].getList(token, folderURL, "collection", function(list, rootPath){
									for (j in list)
										element.splice(element.length, 0, 
											[{
												name: list[j].name,
												path: rootPath + "/" + list[j].name,
												url: list[j].url
											}]
										);
										neworkGUI.fprint(1);
										if(fun) fun.apply(treeView, params);
								}, [rootPath]);
							}, [rootPath, folderURL]);
						}, [path]);
					}
					break;
				case "simplenote":
					QuickFoxNotes.network[service].getList(token, function(IDs, rootPath) {
						try {
							neworkGUI.simplenoteStack = IDs.length;
							for (var i in IDs) {
								var key = IDs[i].key;
								QuickFoxNotes.network[service].getContent(token, key, function(content, key, rootPath){
									if (!content)
										return;
									
									element.splice(element.length, 0, 
										{
											name: content.match(/.*/)[0],
											path: rootPath + "/" + content.match(/.*/)[0].replace("/", "_"),
											content: content,
											key: key
										}
									);
									neworkGUI.simplenoteStack -= 1;
									if(!neworkGUI.simplenoteStack && fun) {
										neworkGUI.fprint(1);
										fun.apply(treeView, params);
									}
								}, [key, rootPath], function (req){
									if (req.status == 401) {
										//Clear login info (User invalid);
										qfnServices.prefs.setCharPref(service + "_username", "");
										neworkGUI.activeServices.splice(neworkGUI.activeServices.indexOf(service), 1);
										return neworkGUI.error (8);
									}
									else if (req.status == 404) {
										//Note does not exist, do not retry
										return neworkGUI.error (9);
									}
									else {
										//Retry
										return neworkGUI.error (10);
									}
								});
							}
						}
						catch (e) {
							return neworkGUI.error (e.message);
						}
					}, [path], function(req){
						if (req.status == 401) {
							neworkGUI.activeServices.splice(neworkGUI.activeServices.indexOf(service), 1);
							return neworkGUI.error (8);
						}
						else {
							//Retry
							return neworkGUI.error (10);
						}
					});
					break;
				case "evernote":
					if (aPath.length == 1) {	//Get list of notebooks
						QuickFoxNotes.network[service].listNotebooks(token, function(notebooks, rootPath){
							for (i in notebooks)
								element.splice(element.length, 0, 
									[{
										name: notebooks[i].name,
										path: rootPath + "/" + notebooks[i].name,
										notebookGuid: notebooks[i].guid
									}]
								);
							neworkGUI.fprint(1);
							if (fun) fun.apply(treeView, params);
						}, [path], function(e){neworkGUI.error(e.responseText)});
					}
					else {
						QuickFoxNotes.network[service].findNotes(token, element[0].notebookGuid, function(notes, rootPath){
							for (i in notes)
								element.splice(element.length, 0, 
									{
										name: notes[i].title,
										path: rootPath + "/" + notes[i].name,
										tagGuids: notes[i].tagGuids,
										guid: notes[i].guid
									}
								);
							neworkGUI.fprint(1);
							if (fun) fun.apply(treeView, params);
						}, [path], function(e){neworkGUI.error(e.responseText)})
					}
					break;
				case "local":
					var url = (aPath.length == 1) ? "/" : element[0].url;

					QuickFoxNotes.network[service].list(url, function(drives, rootPath){
						for (i in drives){
							var item = {
								name: drives[i].name,
								path: rootPath + "/" + drives[i].name,
								url: drives[i].path
							}
							element.splice(element.length, 0, drives[i].isFolder ? [item] : item);
						}
						neworkGUI.fprint(1);
						if (fun) fun.apply(treeView, params);
					}, [path], function(e){neworkGUI.error(e)});
					break;
				default:
					return this.error("This service is not supported!");
			}
		});
	},
	fprint: function(msg_index, msg) {
		var statusbar = QuickFoxNotes.api.statusNotification;
	
		if (typeof(msg_index) != "number") {
			statusbar.show(msg_index);
			return;
		}
		switch(msg_index) {
			case 0:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network2') + " " + msg + "...");
				break;
			case 1:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network1'));
				break;
			case 2:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network3') + "...");
				break;
			case 3:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network4') + "...");
				break;
			case 4:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network5') + "...");
				break;
			case 5:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network6') + "...");
				break;
			case 6:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network7') + "...");
				break;
			case 7:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network10'));
				break;
			case 8:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network11'));
				break;
			case 9:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network12'));
				break;
			case 10:
				statusbar.show(QuickFoxNotes.stringsBundle.getString('network13'));
				break;
		}
	},
	error: function(msg) {
		window.alert("Error:\n\nneworkGUI:\n\n" + msg);
	}
}