/*
* QuickFox Notes by Amin E (InBasic)
* eMail: inb.cor@gmail.com
*
* Source Code License: Mozilla Public License, version 1.1
*/

/**Rename Tab by showing context panel*/
QuickFoxNotes.renameTab = function (e) {
	if (e.target.id != "editor-context")
		return;
		
	var group = _("editor-context-textbox-group").value;
	var label = _("editor-context-textbox-label").value;

	var style = "";
	var bold = _("editor-context-bold").checked;
	if (bold)
		style += "font-weight: bold;";

	var italic = _("editor-context-italic").checked;
	if (italic)
		style += "font-style: italic;";
	var color = _("editor-context-colorpicker").color;
	if (color && !/#000000/.test(color))
		style += "color: "  + color + ";";
	
	this.stylish.write (this.mouseDownTab, {label: this.group.combine(group, label), style: style} );
	
	var lock = _("editor-context-lock").checked;
	var index = this.mouseDownTab.parentNode.getIndexOfItem(this.mouseDownTab);
	if (lock) {
		this.mouseDownTab.setAttribute ("readonly", true);
		this.getEditor(index).setAttribute ("readonly", true);
	}
	else {
		this.mouseDownTab.removeAttribute ("readonly");
		this.getEditor(index).removeAttribute ("readonly");
	}
	
	//Refresh Toolbar
	this.toolbar.controller.onpopupshowing(_("editor-tabbox-toolbar"));

	this.getEditor().focus();
	
	this.mouseDownTab.saveMe = true;
};
QuickFoxNotes.showPopupContext = function (e) {
	if (e.target.id != "editor-context")
		return;

	var groupBox = _("editor-context-textbox-group");
	var labelBox = _("editor-context-textbox-label");
	
	labelBox.value = this.group.readLabel(this.mouseDownTab);
	groupBox.value = this.group.readGroup(this.mouseDownTab);
	groupBox.setAttribute("autocompletesearchparam", qfnServices.nativeJSON.encode(this.group.readGroups()));

	labelBox.selectionStart = 0;	//Select whole text
	labelBox.selectionEnd = labelBox.value.length;
	labelBox.focus();

	_("editor-context-italic").setAttribute("checked", this.stylish.readItalic(this.mouseDownTab));
	_("editor-context-bold").setAttribute("checked", this.stylish.readBold(this.mouseDownTab));
	_("editor-context-lock").setAttribute("checked", this.mouseDownTab.getAttribute('readonly'));
	_("editor-context-colorpicker").color = this.stylish.readColor(this.mouseDownTab);
};