var qfn_editor = {
	_url: "chrome://qfnotes/content/editor.xul",
	stringsBundle: null,
	
	//Find QFN
	qfn: function () {
		var browserEnumerator = qfnServices.wm.getEnumerator("navigator:browser");
		while (browserEnumerator.hasMoreElements()) {
			var browserWin = browserEnumerator.getNext();
			var tabbrowser = browserWin.gBrowser;
			
			var numTabs = tabbrowser.browsers.length;
			for (var index = 0; index < numTabs; index++) {
				var currentTab = tabbrowser.tabContainer.childNodes[index];
				var currentTabURL = tabbrowser.getBrowserAtIndex(index).currentURI.spec;

				if (currentTabURL == this._url)
					return tabbrowser.getBrowserForTab(currentTab).contentWindow.wrappedJSObject;
			}
			var contentsplitter = browserWin.document.getElementById("quickfox-notes-contentsplitter");
			if (contentsplitter.getAttribute("collapsed") == "false")
				return browserWin.document.getElementById("quickfox-notes-browser").contentWindow;
		}
		browserEnumerator = qfnServices.wm.getEnumerator("editor:qfn");
		while (browserEnumerator.hasMoreElements()) {
			return browserEnumerator.getNext();
		}
	},
	
	get: function (aID) {
		return document.getElementById(aID);
	},
	initialize: function () {
		//Services
		Components.utils.import("resource://qfn/qfnServices.js");
		//Init 
		this.stringsBundle = this.get("overlay-bundle");
		
		Components.utils.import("resource://qfn/openInSingleMode.js");
		
		//Which application the code is running on.
		const FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}"; 
		const THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}"; 
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
		if(qfnServices.prefs.getCharPref("currentVersion") == "0" && appInfo.ID != FIREFOX_ID) { //Running under !Firefox for First time!
			qfnServices.prefs.setIntPref("repositoryType", 1); //Switch to local mode
		}		
	
		this.get("qfn.keyset.Key1").setAttribute("modifiers", qfnServices.prefs.getCharPref("modifier"));
		this.get("qfn.keyset.Key1").setAttribute("key", qfnServices.prefs.getCharPref("key"));
		switch(qfnServices.prefs.getIntPref("shortcutWindowType")) {
			case 0:	//Window mode
				this.get("qfn-backpopup").childNodes[0].setAttribute("key", "qfn.keyset.Key1");
				this.get("qfn.keyset.Key1").setAttribute("command", "cmd_openwindow");
				break;
			case 1:	//Tab mode
				this.get("qfn-backpopup").childNodes[1].setAttribute("key", "qfn.keyset.Key1");
				this.get("qfn.keyset.Key1").setAttribute("command", "cmd_opentab");
				break;
			case 2:
				this.get("qfn-backpopup").childNodes[2].setAttribute("key", "qfn.keyset.Key1");
				this.get("qfn.keyset.Key1").setAttribute("command", "cmd_openappcontent");
		}

		
		this.show_welcome_screen_if_needed();
		//Check to see whether reminder is required or not
		var sec = qfnServices.prefs.getIntPref("ReminderSec");
		if (sec) {
			setTimeout(function () {
				switch(qfnServices.prefs.getIntPref("reminderWindowType"))
				{
				case 2:
					qfn_openInSingleMode.openInSidebar(window);
					break;
				case 1:
					qfn_openInSingleMode.openInTab(); 
					break;
				default:
					qfn_openInSingleMode.openInWindow();
				}
			}, sec * 1000);
		}
		//Hide icons if required!
		this.get("quickfox-notes-statusbarpanel1").hidden = !qfnServices.prefs.getBoolPref("statusbarWindowIcon");
		try {	//These are not available in Thunderbird
			this.get("quickfox-notes-statusbarpanel2").hidden = !qfnServices.prefs.getBoolPref("statusbarTabIcon");
			this.get("quickfox-notes-statusbarpanel3").hidden = !qfnServices.prefs.getBoolPref("statusbarAppcontentIcon");
		} catch(e){}
		
		var menu = this.get("contentAreaContextMenu");
		if (!menu)	//For Thunderbird
			menu = this.get("mailContext");
	
		menu.addEventListener("popupshowing", this.contextMenu, false);

	},
	
	show_welcome_screen_if_needed : function() {
		//Detect Firefox version
		var version = "";
		try {
			version = navigator.userAgent.match(/Firefox\/([\d\.]*)/)[1];
		} catch (e) {}
		function welcome (version) {
			if(qfnServices.prefs.getCharPref("currentVersion") == version)
				return;
			//Showing welcome screen
			setTimeout(function() {
				var newTab = getBrowser().addTab('http://inbasic.mozdev.org/root/ext3/home/index.html#FAQ');
				getBrowser().selectedTab = newTab;
		
			}, 1000);
			qfnServices.prefs.setCharPref("currentVersion", version);
		}
		
		//FF < 4.*
		if (version < "4.") {
			var addon = qfnServices.extMan.getItemForID("amin.eft_bmnotes@gmail.com");
			welcome(addon.version);
		}
		//FF > 4.*
		else {
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			AddonManager.getAddonByID("amin.eft_bmnotes@gmail.com", function(addon) {
				welcome(addon.version);
			});
		}
	},
	clickHandle: function (e) {
		if (e.button == 0) {
			switch(qfnServices.prefs.getIntPref('toolbarLeftClick'))
			{
			case 0:
				qfn_openInSingleMode.openInWindow(); 
				break;
			case 1:
				qfn_openInSingleMode.openInTab(); 
				break;
			case 2:
				qfn_openInSingleMode.openInSidebar(window);
			}
		}
		if (e.button == 1) {
			switch(qfnServices.prefs.getIntPref('toolbarMiddleClick'))
			{
			case 0:
				qfn_openInSingleMode.openInWindow(); 
				break;
			case 1:
				qfn_openInSingleMode.openInTab(); 
				break;
			case 2:
				qfn_openInSingleMode.openInSidebar(window);
			}
		}
	},
	contextMenu: function () {
		if(!(gContextMenu)) 
			return;
		
		var menuitem1 = qfn_editor.get("qfn-context1");
		var menuitem2 = qfn_editor.get("qfn-context2");
		var menu1 = qfn_editor.get("qfn-context3");
		var menu2 = qfn_editor.get("qfn-context4");
		
		if (!menuitem1)
			return;
		
		if (!menuitem2) {	//In Thunderbird there is no detail send
			menuitem2 = menu2 = {};
		}
		
		var qfn = qfn_editor.qfn();
		
		//gContextMenu.isContentSelected is for Thunderbird
		var showMe = !(gContextMenu.onLink || gContextMenu.isTextSelected || gContextMenu.isContentSelected) || qfnServices.prefs.getBoolPref ("doNoteShowInContext");
		if (showMe) {
			menuitem1.hidden = menuitem2.hidden = menu1.hidden = menu2.hidden = showMe;
			return;
		}
		
		if(qfn) {
			var notes = qfn.QuickFoxNotes.api.list.tab();
			var menupopup1 = qfn_editor.get("qfn-context3-popup");
			var menupopup2 = qfn_editor.get("qfn-context4-popup");
			//Remove old childs
			while (menupopup1.firstChild)
				menupopup1.removeChild(menupopup1.firstChild);
			while (menupopup2 && menupopup2.firstChild)
				menupopup2.removeChild(menupopup2.firstChild);
			//Add new list
			
			
			
			for (var i = 0; i < notes.length; i++) {
				var mi1 = document.createElement("menuitem");
				mi1.setAttribute("label", notes[i].label);
				mi1.setAttribute("value", (i+1)); //First note is dummy!
				
				var mi2 = mi1.cloneNode(false);

				menupopup1.appendChild(mi1);
				if (menupopup2)	//In Thunderbird there is no detail send
					menupopup2.appendChild(mi2);
			}
		}
		menu1.hidden = menu2.hidden         = qfn ? false : true;
		menuitem1.hidden = menuitem2.hidden = qfn ? true : false;
	},
	sendToQFN: function (details, data, index) {
		var text;
		//Find main window
		if (details && !tabBrowser) {
			var mainWindow = qfnServices.wm.getMostRecentWindow('navigator:browser');
			var tabBrowser = mainWindow.getBrowser();
		}
		//Post text 
		var postText = (details ? "\n" + "{" : "") + 
				       (details ? tabBrowser.currentURI.spec + "}" : "") + "\n";
		//Find selected text
		if (data) {
			text = data;
		}
		else if (gContextMenu.onLink && !gContextMenu.isTextSelected) {
			text = "\n" + gContextMenu.linkURL +  postText;
		}
		else {
			var focusedWindow = document.commandDispatcher.focusedWindow;	//Taken from QuickNote
			text = "\n" + Components.lookupMethod(focusedWindow, "getSelection").apply(focusedWindow, []) + postText;	// i.e. focusedWindow.getSelection();
		}

		var str = qfnServices.str;
		str.data = text;
		qfnServices.prefs.setComplexValue("pasteMeAfterInit", Components.interfaces.nsISupportsString, str); 
		qfnServices.prefs.setCharPref("qfnPrefCMD", (index ? "pasteText" + index : "pasteText"));
		//Open QFN if it is close
		setTimeout(function(prefs, open){
			if (qfnServices.prefs.getCharPref("qfnPrefCMD") == "pasteText")
				open.openInWindow();	
		}, 300, qfnServices.prefs, qfn_openInSingleMode);
	}
};

window.addEventListener("load", function() {qfn_editor.initialize()}, false); 